<?php

use WSCOMUN\WSComunFClient;

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../include/WSComunFClient.php';
$keyGDE2 		= WSComunFClient::KEYCLIENTE_GDE2;

/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyGDE2 => 'https://instrumental-pre.gva.es/pai_bus_ins/GDE/GDEService_v2_00?wsdl'	// Instrumentales
		//$keyGDE2 => 		'https://preinterint.gva.es/eSirca_Bus/ins/Proxy/GDE/GdeWSService_v2_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
$v_datosCertif = array
(
	'certFile'	=> realpath('../../cert/SELLO-SCOR-PRE.crt'),
	'keyFile'	=> realpath('../../cert/SELLO-SCOR-PRE.key'),
	'passPhrase'=> null
);

$vTrazabilidad = array
(
	'nsCert'=>	'2039d6a41976eedf',
	'idApp'=>	'WSCOMUN'
);


//Parametros de invocacin generales
$codApp = 'RABA';
$path = '2015_v2_test_soapUI_eliminar';
$metadatosExpedienteEni = array(
		'versionNTI' => 'http://administracionelectronica.gob.es/ENI/XSD/v1.0/documento-e',
		'organo' => array( 'A10000PRE' ),	 // 1 or more
		'identificador' => 'ES_A10000PRE_2013_EXP_000000000000000000000001183638',
		'fechaAperturaExpediente' => new DateTime('2015-05-20T11:29:38.468+02:00'),
		'estado' => 'E01',
		'clasificacion' => 'CLASIFICACION',
		'interesado' => array( 'lmhubeda' ) // 1 or more
);
$coleccionMetadatosPersonalizados = array(
	array(
		'idColeccionMetadatosPersonalizados' => 'gde:incorporable',
		'tipoColeccion' => 'ASPECTO',
		'metadatosPersonalizados' => array(
			array(
				'idMetaDatoPers' => 'gde:eni_u_t_fecha_incorporacion_expediente',
				'tipoMetaDatoPers' => 'FECHA',
				'valorMetaDatoPers' => array( new DateTime('2015-05-20T11:29:38.468+02:00') )
			)
		)
	)
);

print("\n\n<br><br><br>Prueba de GDE2: crearCarpetaGDE2($codApp, $path)<br>\n");

try
{
	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_GDE2, $v_wsdl, array_merge($v_datosCertif, $vTrazabilidad));
	$clienteSIRCA->setDebugMode(true);
	$clienteSIRCA->loadTracertPAI($vTrazabilidad);

	$respuestaGDE2 = $clienteSIRCA->crearCarpetaGDE2($codApp, $path, null, $metadatosExpedienteEni, $coleccionMetadatosPersonalizados);

	echo "Carpeta '" . $path . "' creada correctamente: " . ($respuestaGDE2['respuesta']['correcto'] != 'false' ? "True" : "False");
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

?>