<?php

use WSCOMUN\WSComunFClient;

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../include/WSComunFClient.php';
$keyGDE2 		= WSComunFClient::KEYCLIENTE_GDE2;

/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyGDE2 => 'https://instrumental-pre.gva.es/pai_bus_ins/GDE/GDEService_v2_00?wsdl'	// Instrumentales
		//$keyGDE2 => 		'https://preinterint.gva.es/eSirca_Bus/ins/Proxy/GDE/GdeWSService_v2_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
$v_datosCertif = array
(
	'certFile'	=> realpath('../../cert/SELLO-SCOR-PRE.crt'),
	'keyFile'	=> realpath('../../cert/SELLO-SCOR-PRE.key'),
	'passPhrase'=> null
);

$vTrazabilidad = array
(
	'nsCert'=>	'2039d6a41976eedf',
	'idApp'=>	'WSCOMUN'
);


//Parametros de invocacin generales
$codApp = 'RABA';
$refDoc ='RABAbf83f791-b77c-4b53-a7b7-0e90dd12a3aa';
$vMetaENI = array(
	'versionNTI' => 'http://administracionelectronica.gob.es/ENI/XSD/v1.0/documento-e',
	'identificador' => 'ES_A10000PRE_2013_000000000000000000000000183638',
	'tipoDocumental' => 'TD99',
	'nombreFormato' => '4',
	'organo' => array( 'A10000PRE' ),		// 1 or more
	'fechaCaptura' => new DateTime('2017-05-20T11:29:38.468+02:00'),
	'estadoElaboracion' => 'EE99',
	'origenCiudadanoAdministracion' => true,
	'identificadorDocumentoOrigen' => '9',
	'fechaIncorporacionExpediente' => new DateTime('2012-05-20T11:29:38.468+02:00')
);

try
{
	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_GDE2, $v_wsdl, array_merge($v_datosCertif, $vTrazabilidad));
	$clienteSIRCA->setDebugMode(true);
	$clienteSIRCA->loadTracertPAI($vTrazabilidad);


	$respuestaGDE2 = $clienteSIRCA->establecerMetadatosENIGDE2($codApp, $refDoc, $vMetaENI);

	//var_dump($respuestaGDE2);
	echo "Documento: $refDoc<br>\n";
	echo "MetadatosENI asociados correctamente: " . ($respuestaGDE2['respuesta']['correcto'] != 'false' ? "True" : "False");
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

?>