<?php

use WSCOMUN\WSComunFClient;

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
require_once '../../../include/WSComunFClient.php';
$keyGDE2 = WSComunFClient::KEYCLIENTE_GDE2;

/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyGDE2 => 'https://innovacion-pre.gva.es/pai_bus_inno/GDE/GDEService_v2_00?wsdl'	// Instrumentales
);

/* Datos del certificado utilizado para las pruebas */
$v_opciones = array
(
		//'certFile'	=> realpath('../../../cert/SELLO-SCOR-PRE.crt'),
		//'keyFile'	=> realpath('../../../cert/SELLO-SCOR-PRE.key'),
		'passPhrase' 			=> null,
		'enableWSSecurity' 		=> false, //Innovacion
		'enableTrazabilidadPAI' => true,
		'idApp' 				=> 'WSCOMUN',
);

$codApp = 'RABA';

$debugMode = false;	// A true, muestra log de los pasos | A false, descarga el zip generado

try
{
	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient($keyGDE2, $v_wsdl, $v_opciones);
	$clienteSIRCA->setDebugMode(true);

	// CrearCarpeta
	$path = 'testObtenerExpediente';
	$metadatosExpedienteEni = array(
			'versionNTI' => 'http://administracionelectronica.gob.es/ENI/XSD/v1.0/documento-e',
			'organo' => 'A10000PRE',
			'identificador' => 'ES_A10000PRE_2013_EXP_000000000000000000000001234567',
			'fechaAperturaExpediente' => new DateTime('2015-05-20T11:29:38.468+02:00'),
			'estado' => 'E01',
			'clasificacion' => 'CLASIFICACION',
			'interesado' => array( 'lmhubeda' ) // 1 or more
	);
	$coleccionMetadatosPersonalizados = array(
			array(
					'idColeccionMetadatosPersonalizados' => 'gde:incorporable',
					'tipoColeccion' => 'ASPECTO',
					'metadatosPersonalizados' => array(
							array(
									'idMetaDatoPers' => 'gde:eni_u_t_fecha_incorporacion_expediente',
									'tipoMetaDatoPers' => 'FECHA',
									'valorMetaDatoPers' => array( new DateTime('2015-05-20T11:29:38.468+02:00') )
							)
					)
			)
	);

	$respuestaGDE2 = $clienteSIRCA->crearCarpetaGDE2($codApp, $path, null, $metadatosExpedienteEni, $coleccionMetadatosPersonalizados);
	if ($debugMode) {
		print("<br>\nCarpeta '" . $path . "' creada correctamente: " . ($respuestaGDE2['correcto'] ? "True" : "False"). "<br>\n");
	}



	// InsertarDocumento
	$contenidoPDF = file_get_contents('..\PDFSinFirmar.pdf');
	$contenidoPDFB64 = base64_encode ($contenidoPDF);
	$nombreDoc = $path .'/'. 'pruebaGDE2_'.date('YmdHis').'.pdf';

	$respuestaGDE = $clienteSIRCA->insertarDocumentoGDE2($codApp, $contenidoPDFB64, $nombreDoc);
	$refDoc = $respuestaGDE['referenciaDocumento'];
	if ($debugMode) {
		print("<br>\nPrueba de GDE: insertarDocumentoGDE2($codApp, CONTENIDOPDF, $nombreDoc)<br>\n");
		print("<br>\nDocumento insertado. Referencia: $refDoc<br>\n");
	}



	// GenerarIdentificadorENI
	$respuestaGDE2 = $clienteSIRCA->generarIdentificadorENIGDE2($codApp);
	$idENI = $respuestaGDE2['identificadorENI'];
	if ($debugMode) {
		print("<br>\nIdentificador ENI: $idENI<br>\n");
	}



	// EstablecerMetaDatosEni
	$codApp = 'RABA';
	$vMetaENI = array(
			'versionNTI' => 'http://administracionelectronica.gob.es/ENI/XSD/v1.0/documento-e',
			'identificador' => $idENI,
			'tipoDocumental' => 'TD99',
			'nombreFormato' => '4',
			'organo' => array( 'A10000PRE' ),		// 1 or more
			'fechaCaptura' => new DateTime(),
			'estadoElaboracion' => 'EE99',
			'origenCiudadanoAdministracion' => true,
			'identificadorDocumentoOrigen' => '9',
			'fechaIncorporacionExpediente' => new DateTime()
	);

	$respuestaGDE2 = $clienteSIRCA->establecerMetadatosENIGDE2($codApp, $refDoc, $vMetaENI);
	if ($debugMode) {
		print("<br>\nDocumento: $refDoc<br>\n");
		print("MetadatosENI asociados correctamente: " . ($respuestaGDE2['correcto'] ? "True" : "False") . "<br>\n");
	}



	// AsociarFirmas
	$respuestaGDE2 = $clienteSIRCA->asociarFirmasGDE2($codApp, $refDoc,
			array(
					array(
							'tipo' => 'TF01',
							'fechaFirma' => new DateTime(),
							'CSV' => 'CKDK49390909FJ8984JF9834JF',
							'regCSV' => 'BOE'
					)
			));
	if ($debugMode) {
		print("<br>\nDocumento: $refDoc<br>\n");
		print("Firma asociada correctamente: " . ($respuestaGDE2['correcto'] ? "True" : "False") . "<br>\n");
	}



	// establecerMetadatosPersonalizadosGDE2
	$vMetaPers = array(
			array(
					'idColeccionMetadatosPersonalizados' => 'P:gde:mezquita_datos_contenido', // 'P:otro:identificable',
					'tipoColeccion' => 'ASPECTO',
					'metadatosPersonalizados' => array(
							array(
									'idMetaDatoPers' => 'gde:mez_u_s_sensibilidad_LOPD', // P:otro:id',
									'tipoMetaDatoPers' => 'CADENA',
									'valorMetaDatoPers' => array( 'A' )	// 0 or more
							)
					)
			), array(
					'idColeccionMetadatosPersonalizados' => 'gdg:doc_gustavo', // 'P:otro:identificable',
					'tipoColeccion' => 'ASPECTO',
					'metadatosPersonalizados' => array(
							array(
									'idMetaDatoPers' => 'gdg:doc_u_s_id_expediente', // P:otro:id',
									'tipoMetaDatoPers' => 'CADENA',
									'valorMetaDatoPers' => array( '0' )	// 0 or more
							)
					)
			)
	);

	$respuestaGDE2 = $clienteSIRCA->establecerMetadatosPersonalizadosGDE2($codApp, $refDoc, $vMetaPers);
	if ($debugMode) {
		print("<br>\nDocumento: $refDoc<br>\n");
		print("MetadatosPersonalizados asociados correctamente: " . ($respuestaGDE2['correcto'] ? "True" : "False") . "<br>\n");
	}



	// obtenerExpedienteENIGDE2
	$vRefDoc = array( $refDoc /*'RABAbf83f791-b77c-4b53-a7b7-0e90dd12a3aa'*/ );
	$vMetaENI = array(
		'versionNTI' => 'http://administracionelectronica.gob.es/ENI/XSD/v1.0/documento-e',
		'organo' => array( 'A10000PRE' ), // 1 or more
		'identificador' => 'ES_A10000PRE_2013_EXP_000000000000000000000001234567',
		'fechaAperturaExpediente' => new DateTime('2014-07-23T09:25:17.030+02:00'),
		'estado' => 'E01',
		'clasificacion' => 'CLASIFICACION',
		'interesado' => array( 'lmhubeda' ) // 1 or more
	);
	$idCertificadoSafe = '5';
	$idSesionSafe = 'TRA';

	$respuestaGDE2 = $clienteSIRCA->obtenerExpedienteENIGDE2($codApp, $vRefDoc, $vMetaENI, $idCertificadoSafe, $idSesionSafe);
	if ($debugMode) {
		print("<br>\Respuesta de obtenerExpedienteENIGDE2<br>\n");
		var_dump($respuestaGDE2);die;
	} else {
		// Genera el fichero para descarga (con extension temporal)
		$contenido = base64_decode( $respuestaGDE2['expedienteElectronicoENI'] );

		ob_end_clean();
		ob_start();
		header("Content-Type: application/zip");
		header("Content-Disposition: attachment; filename='expENI.zip'");
		header('Expires: 0');
		header('Pragma: cache');
		header('Cache-Control: private');
		echo $contenido;
		ob_end_flush();
	}


}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

?>