<?php

use WSCOMUN\WSComunFClient;

//error_reporting(E_ERROR | E_WARNING | E_PARSE);
error_reporting(E_ALL);
ini_set('display_errors', 1);

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../../include/WSComunFClient.php';

$keyRD 		= WSComunFClient::KEYCLIENTE_REGDEPARTAMENTAL;


/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyRD => 'https://innovacion-pre.gva.es/pai_bus_inno/RD/RegistroDepartamentalService_v1_00?wsdl'
);


$vTrazabilidad = array
(
		'idApp'=>	'WSCOMUN'			//WSCOMUN
);



// Parametros de la consulta
$codDep = '04UDEP/2018/1/E';
$fechaStr = '20180206145609';



try
{
	// Creacin del cliente
	set_time_limit(40);
	$clienteWS = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_REGDEPARTAMENTAL, $v_wsdl, $vTrazabilidad);
	$clienteWS->setDebugMode(true);

	// Consulta al WS
	$oRespWS = $clienteWS->consultaHistorico($codDep, $fechaStr);

	// Muestra los resultados
	echo("Resultado: " . $oRespWS->getResultado() . "<br>\r\n");
	echo("Reg.Departamental de la consulta: " . $oRespWS->getCodigoRegistroDepartamentalConsulta()->getCodigoRegistro() . " | " . $oRespWS->getCodigoRegistroDepartamentalConsulta()->getFechaRegistro() . "<br>\r\n");

	$oReg = $oRespWS->getHistorico()->getRegistros();
	echo("Reg.Historico: " . $oReg->getTipoRegistro() . " [" . $oReg->getCodigoRegistro() . " | " . $oReg->getFechaRegistro() . "]<br>\r\n");
	echo("-- Tiene registros descendientes: " . ($oReg->hasRegistroDescendente() ? "SI" : "NO") . "<br>\r\n");
	echo("<br>\r\n\r\n");

	echo('<pre>');print_r($oRespWS);echo('</pre>');
}
catch (\WSCOMUN\WSComunPAIException $e)
{
	print("\n<br/>Excepcion PAI: \n<br/>");
	print("  - ERROR: " . $e);print("\n<br/>");
	print("  - CODIGO: " . $e->getCode());print("\n<br/>");
	print("  - MENSAJE: " . $e->getMessage());print("\n<br/>");

	var_dump($e);
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = $clienteWS->getDebugInfo();
	print_r($vDebugInfo);
	print('</pre>');
}

?>
